## emscripten 3.1.66~dfsg

=== debian/changelog ===
emscripten (3.1.66~dfsg-2) unstable; urgency=medium

  * QA upload
  * debian/clean: Skip contrib ports
    contrib.glfw3 downloads tarballs from github during build. To avoid the
    download, disable the build of the glfw3 port.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 14 Sep 2024 23:54:34 +0200

emscripten (3.1.66~dfsg-1) unstable; urgency=medium

  [ Bastian Germann ]
  * QA upload.
  * d/copyright: Files-Excluded for next version.
  * New upstream version 3.1.61~dfsg.
  * Update patches for (re)moved files.
  * Update to llvm 18. (Closes: #1061212)
  * Download current emscripten-source-map.min.js.
  * Use llvm 18 in patches

  [ Sebastian Ramacher ]
  * New upstream version 3.1.66~dfsg
  * debian/patches/Refresh patches for new upstream version
  * debian/missing-sources: Add new source-map-footer.js
  * debian/rules: Update files to add/remove executable flag

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 14 Sep 2024 14:58:58 +0200

emscripten (3.1.6~dfsg-9) unstable; urgency=medium

  * QA upload.
  * Add upstream patch for Node 18

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 05 Jun 2024 15:58:13 +0200

emscripten (3.1.6~dfsg-8) UNRELEASED; urgency=medium

  * QA upload.
  * Fix building twice in a row.  (Closes: #1044915)
  * Add upstream metadata.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Apr 2024 11:37:12 +0200

emscripten (3.1.5~dfsg-4) unstable; urgency=medium

  * QA upload.
  * Drop version locking for binaryen (Closes: #1011708).
    It works with newer versions.

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 05 Jul 2022 14:06:13 +0200

=== debian/control ===
Source: emscripten
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 binaryen <!nocheck>,
 clang-18 <!nocheck>,
 cmake <!nocheck>,
 cmark-gfm <!nodoc>,
 debhelper-compat (= 13),
 dh-sequence-python3,
 eslint <!nocheck>,
 fonts-liberation <!nocheck>,
 help2man,
 htmlmin <!nocheck>,
 jq,
 libjs-source-map,
 libsimde-dev,
 lld-18 <!nocheck>,
 llvm-18 <!nocheck>,
 node-acorn <!nocheck>,
 node-source-map <!nocheck>,
 nodejs (>= 12.16) <!nocheck>,
 python3,
 python3-numpy <!nocheck>,
 python3-ply <!nocheck>,
 scons <!nocheck>,
 wabt (>= 1.0.24-2~) <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nocheck>,
 python3-sphinx <!nodoc>,
Standards-Version: 4.6.0
Homepage: http://emscripten.org/
Vcs-Browser: https://salsa.debian.org/debian/emscripten
Vcs-Git: https://salsa.debian.org/debian/emscripten.git
Rules-Requires-Root: no

Package: emscripten
Architecture: all
Depends:
 binaryen,
 clang-18,
 lld-18,
 llvm-18,
 node-acorn,
 nodejs (>= 12),
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 libjs-d3,
 python3-numpy,
Suggests:
 adb,
 automake,
 closure-compiler,
 cmake,
 emscripten-doc,
 make,
 python3-ply,
 scons,
 wabt (>= 1.0.24-2~),
Provides:
 node-types-emscripten (= ${types:Version}),
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 Some uses of emscripten require additional packages:
  * setting WASM2C requires wabt (at least release 1.0.24-2).
  * emcmake requires cmake.
  * emconfigure may require automake.
  * emmake requires make.
  * emrun option --android requires adb.
  * emscons requires scons.
  * WebIDL Binder requires python3-ply.

Package: emscripten-doc
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Architecture: all
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION_UPSTREAM DEB_DISTRIBUTION
include /usr/share/dpkg/pkg-info.mk

# resolve DEB_BUILD_OPTION_PARALLEL
-include /usr/share/dpkg/buildopts.mk

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

DEB_VERSION_UPSTREAM_ORIG = $(firstword $(subst ~,$() ,$(DEB_VERSION_UPSTREAM)))

DOCS_SRC = README.md
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DOCS = $(DOCS_SRC:md=html) $(DOCS_SRC:md=txt)
CHANGELOGS = ChangeLog.html ChangeLog.txt
endif

_ENV = $(strip \
 PATH="$(CURDIR)/debian/tmpbin:$$PATH" \
 EM_CACHE="$(CURDIR)/debian/em_cache")

# generate manpage with help2man from --help option of python script
_mkman = $(_ENV) \
 help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
 || { $(_ENV) $1 --help; false; }
_mkman_sloppy = $(_ENV) \
 help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
 || true

ifneq (,$(DEB_BUILD_OPTION_PARALLEL))
export EMCC_CORES=$(DEB_BUILD_OPTION_PARALLEL)
endif

EMCC = $(_ENV) emcc
TESTS_RUNNER = $(_ENV) EMTEST_LACKS_CLOSURE_COMPILER=1 EMTEST_SKIP_V8=1 tests/runner.py --skip-slow

# files generated during build
SOURCE_MAP_MIN_JS = src/emscripten-source-map.min.js
NEON_H = system/include/compat/arm_neon.h

# libraries available for compilation (ports are unavailable)
LIBS_ALL = $(shell $(_ENV) embuilder --em-config .emscripten --help \
 | grep -Po '^        \K\S+')
LIBSTEMS_PORTS = $(shell find tools/ports -maxdepth 1 -type f \
 | grep -Po 'tools/ports/\K[a-z]+' | sort -u)
LIBS_MAIN = $(filter-out $(addsuffix %,$(LIBSTEMS_PORTS)),$(LIBS_ALL))

# requires third-party tests
#  * test_freetype also requires symlinked LiberationSansBold.ttf
#  * test_poppler also requires tests.poppler.paper.pdf
ERRORS_core += \
 test_freetype \
 test_lua \
 test_openjpeg \
 test_poppler

# requires Emscripten Ports
ERRORS_other += \
 test_boost_graph \
 test_bullet \
 test_bullet_autoconf \
 test_bullet_cmake \
 test_bzip2 \
 test_cmake_find_sdl2 \
 test_cmake_find_stuff \
 test_cmake_html \
 test_deps_info \
 test_freetype \
 test_giflib \
 test_libjpeg \
 test_libpng \
 test_contrib_ports \
 test_sdl2_config \
 test_sdl2_gfx_linkable \
 test_sdl2_linkable \
 test_sdl2_mixer_wav \
 test_sdl2_ttf \
 test_vorbis

# attempts to download files from a remote server
ERRORS_other += \
 test_icu \
 test_pthread_icu

# avoid unimportant mode causing multiple failures: strict
CHECK_MODES_coreX = core0 core1 core2 core3 cores corez
CHECK_MODES_coreZ = corez wasm2jsz
CHECK_MODES_core23Z = core2 core3 corez
CHECK_MODES_coreJS = wasm2js1 wasm2js2 wasm2js3 wasm2jss wasm2jsz
CHECK_MODES_coreJS1S = wasm2js1 wasm2jss

# expects smaller output
FAILS_core1 += \
 test_emscripten_lazy_load_code_unconditional
FAILS_other += \
 test_function_exports_are_small \
 test_js_function_names_are_minified \
 test_metadce_minimal_pthreads \
 test_minimal_runtime_code_size_*

# needs node module wasm2c
FAILS_other += \
 test_wasm2c_multi_lib \

# requires bugfix for Error: FS error
FAILS_core += \
 test_fs_nodefs_home

# requires bugfix for RuntimeError: memory access out of bounds
FAILS_core += \
 test_pthread_dylink_exceptions

# unreliable; sometimes fails with AssertionError: Expected to find ... pthread sent an error! undefined:undefined: Aborted().
FAILS_core += \
 test_pthread_abort \

# likely requires newer LLVM
ERRORS_core += \
 test_dylink_syslibs_missing_assertions
FAILS_other += \
 test_lld_report_undefined_exceptions

# unknown cause
FAILS_coreX += \
 test_dlfcn_self \
 test_pthread_exit_process \
 test_pthread_proxying
FAILS_other += \
 test_cmake_stdproperty \
 test_embind_finalization \
 test_ld_library_path \
 test_metadce_hello_main_module_2 \
 test_minimal_dynamic \
 test_split_main_module

BIN_WRAPPER_SYMLINK = \
 em++ \
 emar \
 embuilder \
 emcc \
 emcmake \
 em-config \
 emconfigure \
 emmake \
 emranlib \
 emrun \
 emscons \
 emsize

BIN_WRAPPER_TOOLS_SYMLINK = \
 emdump \
 emdwp \
 emnm \
 emprofile \

NONSCRIPT_EXECUTABLE = \
 cache/cache.lock \
 system/lib/libcxx/readme.txt \
 test/other/wasm_sourcemap/foo.wasm \
 test/other/wasm_sourcemap_dead/t.wasm \
 tools/system_libs.py

SCRIPT_NOT_EXECUTABLE = \
 test/embind/build_benchmark \
 test/sourcemap2json.js

override_dh_clean:
	dh_clean -- $(DOCS) $(CHANGELOGS)

override_dh_auto_configure: $(SOURCE_MAP_MIN_JS) $(NEON_H)
# refresh upstream version hints from Debian package
	cp -f emscripten-version.txt emscripten-version.txt.orig
	echo $(DEB_VERSION_UPSTREAM_ORIG) > emscripten-version.txt
	echo $(patsubst $(DEB_VERSION_UPSTREAM_ORIG)-%,%,$(DEB_VERSION_UPSTREAM_ORIG_REVISION)) \
		> emscripten-revision.txt
	tools/create_dom_pk_codes.py
	mkdir -p debian/em_cache
# setup binaries for use during build-time testing
	mkdir --parents debian/tmpbin
	sed "s,/usr/share/emscripten/,$$PWD/," < debian/bin/wrapper > debian/tmpbin/wrapper
	sed "s,/usr/share/emscripten/,$$PWD/," < debian/bin/wrapper-tools > debian/tmpbin/wrapper-tools
	chmod +x debian/tmpbin/wrapper debian/tmpbin/wrapper-tools
	$(foreach symlink,$(BIN_WRAPPER_SYMLINK),ln -fsT wrapper debian/tmpbin/$(symlink);)
	$(foreach symlink,$(BIN_WRAPPER_TOOLS_SYMLINK),ln -fsT wrapper-tools debian/tmpbin/$(symlink);)

execute_before_dh_auto_build:
	$(EMCC) --generate-config

# build frozen cache of non-port libraries unless noopt requested
override_dh_auto_build:
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	$(_ENV) embuilder build $(LIBS_MAIN)
	$(_ENV) embuilder build $(LIBS_MAIN) --lto
	$(_ENV) embuilder build $(LIBS_MAIN) --pic
	$(_ENV) embuilder build $(LIBS_MAIN) --pic --lto
endif
	perl -p \
		-e "s/^# FROZEN_CACHE/FROZEN_CACHE/;" \
		-e "s,^EMSCRIPTEN_ROOT = '\K[^']+,/usr/share/emscripten,;" \
		.emscripten > debian/.emscripten

execute_after_dh_auto_build-arch: $(DOCS) $(CHANGELOGS)

# build documentation unless nodoc requested
execute_after_dh_auto_build-indep: $(DOCS) $(CHANGELOGS)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	sphinx-build -b html site/source debian/doc/html
endif

# disable tests, too many where failing
ifeq (0,1)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(EMCC) tests/hello_world.c
	eslint --no-eslintrc --quiet --env browser --parser-options=ecmaVersion:6 --format unix a.out.js
	$(EMCC) -O3 tests/hello_world.c
	eslint --no-eslintrc --quiet --env browser --parser-options=ecmaVersion:6 --format unix a.out.js
	rm a.out.js a.out.wasm
	ln -sT /usr/share/fonts/truetype/liberation/LiberationSans-Bold.ttf \
		tests/freetype/LiberationSansBold.ttf
	$(TESTS_RUNNER) test_zlib_configure test_zlib_cmake
	$(TESTS_RUNNER) \
		$(CHECK_MODES_coreX) $(CHECK_MODES_coreJS) \
		$(addprefix skip:core*.,$(ERRORS_core) $(FAILS_core)) \
		$(addprefix skip:wasm*.,$(ERRORS_core) $(FAILS_core)) \
		$(addprefix skip:core1.,$(FAILS_core1)) \
		$(addprefix skip:core2.,$(FAILS_core2)) \
		$(foreach mode,$(CHECK_MODES_coreX),\
			$(addprefix skip:$(mode).,$(FAILS_coreX))) \
		$(foreach mode,$(CHECK_MODES_coreZ),\
			$(addprefix skip:$(mode).,$(FAILS_coreZ))) \
		$(foreach mode,$(CHECK_MODES_core23Z),\
			$(addprefix skip:$(mode).,$(FAILS_core23Z))) \
		$(foreach mode,$(CHECK_MODES_coreJS),\
			$(addprefix skip:$(mode).,$(FAILS_coreJS))) \
		$(foreach mode,$(CHECK_MODES_coreJS1S),\
			$(addprefix skip:$(mode).,$(FAILS_coreJS1S))) \
		$(if $(EXP_RELEASE),|| true)
	$(TESTS_RUNNER) other \
		$(addprefix skip:other.,$(ERRORS_other) $(FAILS_other)) \
		$(if $(EXP_RELEASE),|| true)
ifneq (,$(EXP_RELEASE))
	$(TESTS_RUNNER) \
		$(addprefix core1.,$(FAILS_core1)) \
		$(addprefix core2.,$(FAILS_core2)) \
		$(foreach mode,$(CHECK_MODES_coreX) $(CHECK_MODES_coreJS),\
			$(addprefix $(mode).,$(FAILS_core))) \
		$(foreach mode,$(CHECK_MODES_coreX),\
			$(addprefix $(mode).,$(FAILS_coreX))) \
		$(foreach mode,$(CHECK_MODES_coreZ),\
			$(addprefix $(mode).,$(FAILS_coreZ))) \
		$(foreach mode,$(CHECK_MODES_core23Z),\
			$(addprefix $(mode).,$(FAILS_core23Z))) \

## emscripten 3.1.69%2Bdfsg

=== test/cmake/find_pkg_config/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(find_pkg_config)

message(STATUS "PKG_CONFIG_LIBDIR: $ENV{PKG_CONFIG_LIBDIR}")

find_package(PkgConfig REQUIRED QUIET)
if (NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "Could not find pkg-config executable!")
endif()

message(STATUS "Check that all .pc files shipped with Emscripten can be located correctly")
pkg_check_modules(EGL REQUIRED egl)
pkg_check_modules(GLESV2 REQUIRED glesv2)
pkg_check_modules(GLFW3 REQUIRED glfw3)
pkg_check_modules(SDL REQUIRED sdl)

=== test/third_party/poppler/cpp/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file(poppler-version.h.in ${CMAKE_CURRENT_BINARY_DIR}/poppler-version.h @ONLY)

add_subdirectory(tests)

set(poppler_cpp_SRCS
  poppler-document.cpp
  poppler-embedded-file.cpp
  poppler-font.cpp
  poppler-global.cpp
  poppler-image.cpp
  poppler-page.cpp
  poppler-page-renderer.cpp
  poppler-page-transition.cpp
  poppler-private.cpp
  poppler-rectangle.cpp
  poppler-toc.cpp
  poppler-version.cpp
)

add_library(poppler-cpp SHARED ${poppler_cpp_SRCS})
set_target_properties(poppler-cpp PROPERTIES VERSION 0.2.0 SOVERSION 0)
target_link_libraries(poppler-cpp poppler ${ICONV_LIBRARIES})
if(MSVC)
target_link_libraries(poppler-cpp ${poppler_LIBS})
endif(MSVC)
target_link_libraries(poppler-cpp LINK_INTERFACE_LIBRARIES "")
install(TARGETS poppler-cpp RUNTIME DESTINATION bin LIBRARY DESTINATION lib${LIB_SUFFIX} ARCHIVE DESTINATION lib${LIB_SUFFIX})

install(FILES
  poppler-document.h
  poppler-embedded-file.h
  poppler-font.h
  poppler-global.h
  poppler-image.h
  poppler-page.h
  poppler-page-renderer.h
  poppler-page-transition.h
  poppler-rectangle.h
  poppler-toc.h
  ${CMAKE_CURRENT_BINARY_DIR}/poppler-version.h
  DESTINATION include/poppler/cpp)

=== test/third_party/bullet/src/LinearMath/CMakeLists.txt ===

INCLUDE_DIRECTORIES(
	${BULLET_PHYSICS_SOURCE_DIR}/src
)

SET(LinearMath_SRCS
	btAlignedAllocator.cpp
	btConvexHull.cpp
	btConvexHullComputer.cpp
	btGeometryUtil.cpp
	btQuickprof.cpp
	btSerializer.cpp
)

SET(LinearMath_HDRS
	btAabbUtil2.h
	btAlignedAllocator.h
	btAlignedObjectArray.h
	btConvexHull.h
	btConvexHullComputer.h
	btDefaultMotionState.h
	btGeometryUtil.h
	btHashMap.h
	btIDebugDraw.h
	btList.h
	btMatrix3x3.h
	btMinMax.h
	btMotionState.h
	btPoolAllocator.h
	btQuadWord.h
	btQuaternion.h
	btQuickprof.h
	btRandom.h
	btScalar.h
	btSerializer.h
	btStackAlloc.h
	btTransform.h
	btTransformUtil.h
	btVector3.h
)

ADD_LIBRARY(LinearMath ${LinearMath_SRCS} ${LinearMath_HDRS})
SET_TARGET_PROPERTIES(LinearMath PROPERTIES VERSION ${BULLET_VERSION})
SET_TARGET_PROPERTIES(LinearMath PROPERTIES SOVERSION ${BULLET_VERSION})

IF (INSTALL_LIBS)
	IF (NOT INTERNAL_CREATE_DISTRIBUTABLE_MSVC_PROJECTFILES)
		#FILES_MATCHING requires CMake 2.6
		IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 2.5)
			IF (APPLE AND BUILD_SHARED_LIBS AND FRAMEWORK)
				INSTALL(TARGETS LinearMath DESTINATION .)
			ELSE (APPLE AND BUILD_SHARED_LIBS AND FRAMEWORK)
				INSTALL(TARGETS LinearMath DESTINATION lib${LIB_SUFFIX})
				INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
DESTINATION ${INCLUDE_INSTALL_DIR} FILES_MATCHING PATTERN "*.h"  PATTERN
".svn" EXCLUDE PATTERN "CMakeFiles" EXCLUDE)
			ENDIF (APPLE AND BUILD_SHARED_LIBS AND FRAMEWORK)
		ENDIF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 2.5)

		IF (APPLE AND BUILD_SHARED_LIBS AND FRAMEWORK)
			SET_TARGET_PROPERTIES(LinearMath PROPERTIES FRAMEWORK true)
			SET_TARGET_PROPERTIES(LinearMath PROPERTIES PUBLIC_HEADER "${LinearMath_HDRS}")
		ENDIF (APPLE AND BUILD_SHARED_LIBS AND FRAMEWORK)
	ENDIF (NOT INTERNAL_CREATE_DISTRIBUTABLE_MSVC_PROJECTFILES)
ENDIF (INSTALL_LIBS)

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,12 @@
 # resolve if release is experimental
 EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))
 
-DEB_VERSION_UPSTREAM_ORIG = $(firstword $(subst ~,$() ,$(DEB_VERSION_UPSTREAM)))
+# will run a subset of tests generated by test/runner.py randomcore2100, test/runner.py randomwasm2js2100
+TESTS_SUBSET = debian/tests_subset.txt
+
+# Handle both "~dfsg" and the future "+dfsg"
+DEB_VERSION_UPSTREAM_ORIG := $(firstword $(subst ~,$() ,$(DEB_VERSION_UPSTREAM)))
+DEB_VERSION_UPSTREAM_ORIG := $(firstword $(subst +,$() ,$(DEB_VERSION_UPSTREAM_ORIG)))
 
 DOCS_SRC = README.md
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
@@ -26,7 +31,7 @@
  help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
  || { $(_ENV) $1 --help; false; }
 _mkman_sloppy = $(_ENV) \
- help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --output $2 $1 \
+ help2man $(if $3,--name "$(strip $3)") --no-info --version-string $(DEB_VERSION_UPSTREAM) --no-discard-stderr --output $2 $1 \
  || true
 
 ifneq (,$(DEB_BUILD_OPTION_PARALLEL))
@@ -34,7 +39,7 @@
 endif
 
 EMCC = $(_ENV) emcc
-TESTS_RUNNER = $(_ENV) EMTEST_LACKS_CLOSURE_COMPILER=1 EMTEST_SKIP_V8=1 tests/runner.py --skip-slow
+TESTS_RUNNER = $(_ENV) EMTEST_LACKS_CLOSURE_COMPILER=1 EMTEST_SKIP_V8=1 EMTEST_SKIP_WASM64=1 EMTEST_SKIP_EH=1 EMTEST_SKIP_FLAKY=1 EMTEST_SKIP_JSPI=1 test/runner.py --skip-slow --cores=1
 
 # files generated during build
 SOURCE_MAP_MIN_JS = src/emscripten-source-map.min.js
@@ -44,7 +49,8 @@
 LIBS_ALL = $(shell $(_ENV) embuilder --em-config .emscripten --help \
  | grep -Po '^        \K\S+')
 LIBSTEMS_PORTS = $(shell find tools/ports -maxdepth 1 -type f \
- | grep -Po 'tools/ports/\K[a-z]+' | sort -u)
+ | grep -Po 'tools/ports/\K[a-z]+' | sort -u) \
+ $(shell find tools/ports -maxdepth 2 -type f | grep -Po 'tools/ports/\Kcontrib/[a-z0-9]+' | tr / . | sort -u)
 LIBS_MAIN = $(filter-out $(addsuffix %,$(LIBSTEMS_PORTS)),$(LIBS_ALL))
 
 # requires third-party tests
@@ -137,23 +143,23 @@
 
 BIN_WRAPPER_SYMLINK = \
  em++ \
+ em-config \
  emar \
  embuilder \
  emcc \
  emcmake \
- em-config \
  emconfigure \
+ emdump \
+ emdwp \
  emmake \
+ emnm \
+ emprofile \
  emranlib \
  emrun \
  emscons \
- emsize
-
-BIN_WRAPPER_TOOLS_SYMLINK = \
- emdump \
- emdwp \
- emnm \
- emprofile \
+ emsize \
+ emstrip \
+ emsymbolizer
 
 NONSCRIPT_EXECUTABLE = \
  cache/cache.lock \
@@ -180,10 +186,8 @@
 # setup binaries for use during build-time testing
 	mkdir --parents debian/tmpbin
 	sed "s,/usr/share/emscripten/,$$PWD/," < debian/bin/wrapper > debian/tmpbin/wrapper
-	sed "s,/usr/share/emscripten/,$$PWD/," < debian/bin/wrapper-tools > debian/tmpbin/wrapper-tools
-	chmod +x debian/tmpbin/wrapper debian/tmpbin/wrapper-tools
+	chmod +x debian/tmpbin/wrapper
 	$(foreach symlink,$(BIN_WRAPPER_SYMLINK),ln -fsT wrapper debian/tmpbin/$(symlink);)
-	$(foreach symlink,$(BIN_WRAPPER_TOOLS_SYMLINK),ln -fsT wrapper-tools debian/tmpbin/$(symlink);)
 
 execute_before_dh_auto_build:
 	$(EMCC) --generate-config
@@ -209,17 +213,21 @@
 	sphinx-build -b html site/source debian/doc/html
 endif
 
-# disable tests, too many where failing
-ifeq (0,1)
+execute_before_dh_auto_test:
+	ln -sT /usr/share/fonts/truetype/liberation/LiberationSans-Bold.ttf test/freetype/LiberationSansBold.ttf
+
+execute_after_dh_auto_test:
+	rm -f test/freetype/LiberationSansBold.ttf
+
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
-	$(EMCC) tests/hello_world.c
-	eslint --no-eslintrc --quiet --env browser --parser-options=ecmaVersion:6 --format unix a.out.js
-	$(EMCC) -O3 tests/hello_world.c
-	eslint --no-eslintrc --quiet --env browser --parser-options=ecmaVersion:6 --format unix a.out.js
+	pkgjs-install-minimal
+	$(EMCC) test/hello_world.c
+	esbuild --target=es6 a.out.js > /dev/null
+	$(EMCC) -O3 test/hello_world.c
+	esbuild --target=es6 a.out.js > /dev/null
 	rm a.out.js a.out.wasm
-	ln -sT /usr/share/fonts/truetype/liberation/LiberationSans-Bold.ttf \
-		tests/freetype/LiberationSansBold.ttf
+ifeq (,$(TESTS_SUBSET))
 	$(TESTS_RUNNER) test_zlib_configure test_zlib_cmake
 	$(TESTS_RUNNER) \
 		$(CHECK_MODES_coreX) $(CHECK_MODES_coreJS) \
@@ -237,19 +245,13 @@
 			$(addprefix skip:$(mode).,$(FAILS_coreJS))) \
 		$(foreach mode,$(CHECK_MODES_coreJS1S),\
 			$(addprefix skip:$(mode).,$(FAILS_coreJS1S))) \
-		$(if $(EXP_RELEASE),|| true)
 	$(TESTS_RUNNER) other \
-		$(addprefix skip:other.,$(ERRORS_other) $(FAILS_other)) \
-		$(if $(EXP_RELEASE),|| true)
-ifneq (,$(EXP_RELEASE))
-	$(TESTS_RUNNER) \
-		$(addprefix core1.,$(FAILS_core1)) \
-		$(addprefix core2.,$(FAILS_core2)) \
-		$(foreach mode,$(CHECK_MODES_coreX) $(CHECK_MODES_coreJS),\
-			$(addprefix $(mode).,$(FAILS_core))) \
-		$(foreach mode,$(CHECK_MODES_coreX),\
-			$(addprefix $(mode).,$(FAILS_coreX))) \
-		$(foreach mode,$(CHECK_MODES_coreZ),\
-			$(addprefix $(mode).,$(FAILS_coreZ))) \
-		$(foreach mode,$(CHECK_MODES_core23Z),\
-			$(addprefix $(mode).,$(FAILS_core23Z))) \
+		$(addprefix skip:other.,$(ERRORS_other) $(FAILS_other))
+else
+	$(TESTS_RUNNER) $(shell cat $(TESTS_SUBSET) | tr '\n' ' ')
+endif
+endif
+
+execute_after_dh_auto_install:
+	$(call _mkman, debian/tmpbin/em++, debian/em++.1,\
+		emscripten compiler for WASM and JavaScript like g++ or clang++)
